typedef struct {
 float x;
 float y;
 float z;
} vector; 

typedef struct { // vertex at the corners of the cubes
 vector p;
 float  v; //the value of the scalar field at a cube vertes
 vector n;    
} CubeGridVertex; 


// vertex defining the iso-surface mesh position within a cube
// it will lie somewhere along one of the edges of the cube
typedef struct {
 vector p;
 vector n;
} SurfaceMeshVertex;


typedef struct { // each cube in the lattice is defined by its corner vertices
 CubeGridVertex * vertices[8]; //pointers to vertices around the cube
} CubeGridCube;


typedef struct {  // The one and only cube grid
 int nVertices;   // total number of lattice vertices
 CubeGridVertex * vertices; // list of all lattice cube vertices
 int nCubes;      // total number of lattice cubes
 CubeGridCube * cubes;   // list of all lattice cubes
} CubeGrid; 


BOOL CubeGrid_CreateMemory(CubeGrid *);
BOOL CubeGrid_Init(CubeGrid *, int gridSize);
void CubeGrid_DrawSurface(CubeGrid *, float threshold);
void CubeGrid_FreeMemory(CubeGrid *);

