#ifdef _WIN32
#include <windows.h>
#include <mmsystem.h>
#include <GL/gl.h>
#include "gl\glut.h"
#else
#include <sys/time.h>
#include <stdlib.h>
#ifdef __UBUNTU__
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#else
#include <opengl/gl.h>
#include <opengl/glu.h>
#include <GLUT/GLUT.h>
#endif
#define TRUE 1
#define FALSE 0
#define BOOL int
float timeGetTime(void){
 static struct timeval tv;
 gettimeofday(&tv,NULL);
 double t1=(tv.tv_sec) - 1364335233.0;
 double t2=(tv.tv_usec);
 return (t1*1000.0 + t2/1000.0);
}
#endif

#include <stdlib.h>

#include "timer.h"

static  BOOL isPaused;
static double pauseTime;
static double startTime;

void Time_Reset(){
 startTime=(double)timeGetTime();
}

double Time_GetTime(){
 if(isPaused) return pauseTime-startTime;
 else         return ((double)timeGetTime())-startTime;
}

void Time_Pause(){
 if(isPaused)return;  
 isPaused=TRUE;
 pauseTime=(double)timeGetTime();
}

void Time_Unpause(){
 if(!isPaused)return; 
 isPaused=FALSE;
 startTime+=((double)timeGetTime()-pauseTime); 
}
